#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

void kernel_cpu(float *B0,float *B1,float *B2,float *B3,float *B4,float *B5,float *B6,float *B7,float *B8,int N){
for(int i=0;i<N;i++){
B0[i] = B5[i];
B1[i] = B4[i]+B7[i];
B2[i] = B4[i]+B6[i]-B6[i];
}
}

int main(int argc,char **argv) {
int size=789846;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
float *B3;
B3 = (float *)malloc(floatBytes);
float *B4;
B4 = (float *)malloc(floatBytes);
float *B5;
B5 = (float *)malloc(floatBytes);
float *B6;
B6 = (float *)malloc(floatBytes);
float *B7;
B7 = (float *)malloc(floatBytes);
float *B8;
B8 = (float *)malloc(floatBytes);
for(int i=0;i<789846;i++){
B0[i] = 88.8755219676*i+1;
B1[i] = 32.7529526054+i+1;
B2[i] = 58.3479841063*i+1;
B3[i] = 56.6406572737+i+1;
B4[i] = 92.9326655952+i+1;
B5[i] = 97.4991063904+i+1;
B6[i] = 62.0787084664+i+1;
B7[i] = 92.9315314083*i+1;
B8[i] = 14.6547238556*i+1;
}
struct timeval time0,time1;
gettimeofday(&time0,NULL);
FILE *file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "1";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
kernel_cpu(B0,B1,B2,B3,B4,B5,B6,B7,B8,789846);
file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "0";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F); 
free(B0);
free(B1);
free(B2);
free(B3);
free(B4);
free(B5);
free(B6);
free(B7);
free(B8);
printf("\n");return 0; }